"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
}), require("@babel/runtime/helpers/objectWithoutPropertiesLoose"), require("@babel/runtime/helpers/extends");

var css = require("css"), serializer = require("./serializer-16cb6baf.cjs.prod.js"), chalk = _interopDefault(require("chalk")), specificity = require("specificity");

function isA(typeName, value) {
  return Object.prototype.toString.apply(value) === "[object " + typeName + "]";
}

function isAsymmetric(obj) {
  return obj && isA("Function", obj.asymmetricMatch);
}

function valueMatches(declaration, value) {
  return value instanceof RegExp ? value.test(declaration.value) : isAsymmetric(value) ? value.asymmetricMatch(declaration.value) : value === declaration.value;
}

function toHaveStyleRule(received, property, value, options) {
  void 0 === options && (options = {});
  var _options = options, target = _options.target, media = _options.media, classNames = serializer.getClassNamesFromNodes([ received ]), cssString = serializer.getStylesFromClassNames(classNames, serializer.getStyleElements()), preparedRules = css.parse(cssString).stylesheet.rules;
  media && (preparedRules = serializer.getMediaRules(preparedRules, media));
  var result = preparedRules.filter((function(rule) {
    return rule.type === serializer.RULE_TYPES.rule && serializer.hasClassNames(classNames, rule.selectors, target);
  })).reduce((function(acc, rule) {
    var lastMatchingDeclaration = serializer.findLast(rule.declarations, (function(dec) {
      return "declaration" === dec.type && dec.property === property;
    }));
    return lastMatchingDeclaration ? acc.concat(rule.selectors.map((function(selector) {
      return {
        selector: selector,
        declaration: lastMatchingDeclaration
      };
    }))) : acc;
  }), []).sort((function(_ref, _ref2) {
    var selectorA = _ref.selector, selectorB = _ref2.selector;
    return specificity.compare(selectorA, selectorB);
  })).pop();
  if (!result) return {
    pass: !1,
    message: function() {
      return "Property not found: " + property;
    }
  };
  var declaration = result.declaration, pass = valueMatches(declaration, value);
  return {
    pass: pass,
    message: function() {
      return "Expected " + property + (pass ? " not " : " ") + "to match:\n  " + chalk.green(value) + "\nReceived:\n  " + chalk.red(declaration.value);
    }
  };
}

var matchers = {
  toHaveStyleRule: toHaveStyleRule
}, index = {
  print: serializer.print,
  test: serializer.test
};

exports.createSerializer = serializer.createSerializer, exports.print = serializer.print, 
exports.test = serializer.test, exports.default = index, exports.matchers = matchers;
