'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('@babel/runtime/helpers/objectWithoutPropertiesLoose');
require('@babel/runtime/helpers/extends');
require('css');
var serializer = require('../../dist/serializer-3f99148d.cjs.dev.js');
var enzymeToJson = require('enzyme-to-json');

var enzymeSerializer = enzymeToJson.createSerializer({});

var tickle = function tickle(wrapper) {
  if (typeof wrapper.dive === 'function') {
    wrapper.find('EmotionCssPropInternal').forEach(function (el) {
      return el.dive();
    });
  }

  return wrapper;
};

function createSerializer(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      classNameReplacer = _ref.classNameReplacer,
      _ref$DOMElements = _ref.DOMElements,
      DOMElements = _ref$DOMElements === void 0 ? true : _ref$DOMElements;

  var emotionSerializer = serializer.createSerializer({
    classNameReplacer: classNameReplacer,
    DOMElements: DOMElements
  });
  return {
    test: function test(node) {
      return enzymeSerializer.test(node) || emotionSerializer.test(node);
    },
    print: function print(node, printer) {
      var result = node;

      if (enzymeSerializer.test(node)) {
        var tickled = tickle(node);
        result = enzymeSerializer.print(tickled, printer);
      }

      if (emotionSerializer.test(node)) {
        result = emotionSerializer.print(result, printer);
      }

      return result;
    }
  };
}

var _createSerializer = createSerializer(),
    print = _createSerializer.print,
    test = _createSerializer.test;
var enzyme = {
  print: print,
  test: test
};

exports.createSerializer = createSerializer;
exports.default = enzyme;
exports.print = print;
exports.test = test;
