import '@babel/runtime/helpers/objectWithoutPropertiesLoose';
import '@babel/runtime/helpers/extends';
import 'css';
import { d as createSerializer$2 } from '../../dist/serializer-93bf80c6.esm.js';
import { createSerializer as createSerializer$1 } from 'enzyme-to-json';

var enzymeSerializer = createSerializer$1({});

var tickle = function tickle(wrapper) {
  if (typeof wrapper.dive === 'function') {
    wrapper.find('EmotionCssPropInternal').forEach(function (el) {
      return el.dive();
    });
  }

  return wrapper;
};

function createSerializer(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      classNameReplacer = _ref.classNameReplacer,
      _ref$DOMElements = _ref.DOMElements,
      DOMElements = _ref$DOMElements === void 0 ? true : _ref$DOMElements;

  var emotionSerializer = createSerializer$2({
    classNameReplacer: classNameReplacer,
    DOMElements: DOMElements
  });
  return {
    test: function test(node) {
      return enzymeSerializer.test(node) || emotionSerializer.test(node);
    },
    print: function print(node, printer) {
      var result = node;

      if (enzymeSerializer.test(node)) {
        var tickled = tickle(node);
        result = enzymeSerializer.print(tickled, printer);
      }

      if (emotionSerializer.test(node)) {
        result = emotionSerializer.print(result, printer);
      }

      return result;
    }
  };
}

var _createSerializer = createSerializer(),
    print = _createSerializer.print,
    test = _createSerializer.test;
var enzyme = {
  print: print,
  test: test
};

export default enzyme;
export { createSerializer, print, test };
